/* File %M%, version %R%.%L%, released  %E% at %U% 
   retrieved by SCCS %D% at %T%     

%% describe the spectrometer fits data structure

HISTORY
070905 GIL conplete description
070821 GIL initial version of the event capture data structure
DESCRIPTION:
Header describing a captured event.
*/

#ifndef MAXKEYLEN 
#define MAXKEYLEN 40
#endif

#define MAGIC      -99999.          /* magic value blanking */
#define MAXDATASIZE 30000           /* max returned event data */

struct EVENTDATA { 
  long mjd;                         /* computer date of event read */
  double utc;                       /* computer time of event read */
  long eventMjd;                    /* interpolated date of event */
  double eventUtc;                  /* interpolated time of event */
  unsigned long eventClk[2];        /* internal clk at event */
  unsigned long internalClk[2];     /* internal clk */
  unsigned long gpsClk[2];          /* internal clk at last gps 1pps */
  long eventNumber;                 /* event counter number */
  long nData;                       /* actual data received */
  float as[MAXDATASIZE];
  float bs[MAXDATASIZE];
  float cs[MAXDATASIZE];
  float ds[MAXDATASIZE];
}; /* end of struct EVENTDATA */

